#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <errno.h>
#include <string.h>

#include <iostream>
#include <sstream>

#include "expression.h"
#include "parser.h"
#include "parser.c"

using namespace std;


fstream arbre2;
vector <Node> arbre_derive;    //vecteur temporaire qui sert lors de la drivation

extern int errno;

string chaine_temp;

int Copie_de_Arbre(vector <Node> arbre_cur,int indice_node)
{
Node node=arbre_cur[indice_node];
if ((node.Code=='h') || (node.Code=='i') || (node.Code=='C') || (node.Code=='S') || (node.Code=='E') || (node.Code=='R') || (node.Code=='T') || (node.Code=='A') || (node.Code=='L') || (node.Code=='2') || (node.Code=='N') )
{
int a=Copie_de_Arbre(arbre_cur, node.Left_son);
Node node2;
node2.Right_son=-1;
node2.Indice = arbre_derive.size();
node2.Code=node.Code;
node2.Valeur=node.Valeur;
node2.Left_son=a;
arbre_derive.push_back(node2);
return arbre_derive.size()-1;
}
if ((node.Code=='r') || (node.Code=='V'))
        { Node node_derive_bis;
          node_derive_bis.Indice = arbre_derive.size();
          node_derive_bis.Right_son=-1;
          node_derive_bis.Left_son=-1;
          node_derive_bis.Code=node.Code;
          node_derive_bis.Valeur=node.Valeur;
          node_derive_bis.symbole=node.symbole;
          strcpy(node_derive_bis.Name,node.Name);
          arbre_derive.push_back(node_derive_bis);
          return arbre_derive.size()-1;
        }
else
{
int a=Copie_de_Arbre(arbre_cur,node.Left_son);
int b=Copie_de_Arbre(arbre_cur,node.Right_son);
Node node2;
node2.Indice = arbre_derive.size();
node2.Code=node.Code;
node2.Valeur=node.Valeur;
node2.Left_son=a;
node2.Right_son= b;
arbre_derive.push_back(node2);
return arbre_derive.size()-1;
}
}

//Fonction qui transforme un arbre binaire rang dans une liste chain par des entiers en un fichier tex
int Derive_de_Arbre(vector <Node> arbre_cur, int indice_node,string name)
{
Node node=arbre_cur[indice_node];
char e=node.Code;
//driv d'un u*v
if (node.Code=='*')
        {
        int a=Derive_de_Arbre(arbre_cur,node.Left_son, name);
        int b=Copie_de_Arbre(arbre_cur,node.Right_son);
        Node node1;
        node1.Indice = arbre_derive.size();
        node1.Code='*';
        node1.Valeur=0;
        node1.Left_son=a;
        node1.Right_son= b;
        arbre_derive.push_back(node1);

        int c=Copie_de_Arbre(arbre_cur,node.Left_son);
        int d=Derive_de_Arbre(arbre_cur,node.Right_son,name);
        Node node2;
        node2.Indice = arbre_derive.size();
        node2.Code='*';
        node2.Valeur=0;
        node2.Left_son=c;
        node2.Right_son=d;
        arbre_derive.push_back(node2);

        Node node3;
        node3.Indice = arbre_derive.size();
        node3.Code='+';
        node3.Valeur=0;
        node3.Left_son=node1.Indice;
        node3.Right_son=node2.Indice;
        arbre_derive.push_back(node3);
return arbre_derive.size()-1;
        }
//driv d'un quotient u/v
if (node.Code=='/')
        {
        int a=Derive_de_Arbre(arbre_cur,node.Left_son,name);
        int b=Copie_de_Arbre(arbre_cur,node.Right_son);
        Node node1;
        node1.Indice = arbre_derive.size();
        node1.Code='*';
        node1.Valeur=0;
        node1.Left_son=a;
        node1.Right_son= b;
        arbre_derive.push_back(node1);

        int c=Copie_de_Arbre(arbre_cur,node.Left_son);
        int d=Derive_de_Arbre(arbre_cur,node.Right_son,name);
        Node node2;
        node2.Indice = arbre_derive.size();
        node2.Code='*';
        node2.Valeur=0;
        node2.Left_son=c;
        node2.Right_son=d;
        arbre_derive.push_back(node2);

        Node node3;
        node3.Indice = arbre_derive.size();
        node3.Code='-';
        node3.Valeur=0;
        node3.Left_son=node1.Indice;
        node3.Right_son=node2.Indice;
        arbre_derive.push_back(node3);

        Node node4;
        node4.Indice = arbre_derive.size();
        node4.Code='P';
        node4.Valeur=0;
        node4.Left_son=b;
        node4.Right_son=2;
        arbre_derive.push_back(node4);

        Node node5;
        node5.Indice = arbre_derive.size();
        node5.Code='/';
        node5.Valeur=0;
        node5.Left_son=node3.Indice;
        node5.Right_son=node4.Indice;
        arbre_derive.push_back(node5);

return arbre_derive.size()-1;
        }

//driv d'un cos (u)
if (node.Code=='C')
        {
        int a=Derive_de_Arbre(arbre_cur,node.Left_son,name);
        int b=Copie_de_Arbre(arbre_cur,node.Left_son);
        Node node_tmp_3; node_tmp_3.Indice = arbre_derive.size(); node_tmp_3.Code = 'S'; node_tmp_3.Left_son = b; node_tmp_3.Right_son = -1;
        arbre_derive.push_back(node_tmp_3);
        Node node_tmp_2; node_tmp_2.Indice = arbre_derive.size(); node_tmp_2.Code = 'N'; node_tmp_2.Left_son = node_tmp_3.Indice; node_tmp_2.Right_son = -1;
        arbre_derive.push_back(node_tmp_2);
        Node node_tmp; node_tmp.Indice = arbre_derive.size(); node_tmp.Code = '*'; node_tmp.Valeur = 0; node_tmp.Left_son = a; node_tmp.Right_son = node_tmp_2.Indice;
        arbre_derive.push_back(node_tmp);
        return arbre_derive.size()-1;
        }
//driv d'un sinh (u)
if (node.Code=='h')
        {
        int a=Derive_de_Arbre(arbre_cur,node.Left_son,name);
        int b=Copie_de_Arbre(arbre_cur,node.Left_son);
        Node node_tmp_2;
        node_tmp_2.Indice = arbre_derive.size();
        node_tmp_2.Code = 'i';
        node_tmp_2.Left_son = b;
        node_tmp_2.Right_son = -1;
        arbre_derive.push_back(node_tmp_2);
        Node node_tmp;
        node_tmp.Indice = arbre_derive.size();
        node_tmp.Code = '*';
        node_tmp.Valeur = 0;
        node_tmp.Left_son = a;
        node_tmp.Right_son = node_tmp_2.Indice;
        arbre_derive.push_back(node_tmp);
        return arbre_derive.size()-1;
        }
//driv d'un sinh (u)
if (node.Code=='i')
        {
        int a=Derive_de_Arbre(arbre_cur,node.Left_son,name);
        int b=Copie_de_Arbre(arbre_cur,node.Left_son);
        Node node_tmp_2;
        node_tmp_2.Indice = arbre_derive.size();
        node_tmp_2.Code = 'h';
        node_tmp_2.Left_son = b;
        node_tmp_2.Right_son = -1;
        arbre_derive.push_back(node_tmp_2);
        Node node_tmp;
        node_tmp.Indice = arbre_derive.size();
        node_tmp.Code = '*';
        node_tmp.Valeur = 0;
        node_tmp.Left_son = a;
        node_tmp.Right_son = node_tmp_2.Indice;
        arbre_derive.push_back(node_tmp);
        return arbre_derive.size()-1;
        }
//driv d'un sin (u)
if (node.Code=='S')
        {
        int a=Derive_de_Arbre(arbre_cur,node.Left_son,name);
        int b=Copie_de_Arbre(arbre_cur,node.Left_son);
        Node node_tmp_2;
        node_tmp_2.Indice = arbre_derive.size();
        node_tmp_2.Code = 'C';
        node_tmp_2.Left_son = b;
        node_tmp_2.Right_son = -1;
        arbre_derive.push_back(node_tmp_2);
        Node node_tmp;
        node_tmp.Indice = arbre_derive.size();
        node_tmp.Code = '*';
        node_tmp.Valeur = 0;
        node_tmp.Left_son = a;
        node_tmp.Right_son = node_tmp_2.Indice;
        arbre_derive.push_back(node_tmp);
        return arbre_derive.size()-1;
        }
//driv d'une racine
if (node.Code=='R')
        {
        int a=Derive_de_Arbre(arbre_cur,node.Left_son,name);
        int b=Copie_de_Arbre(arbre_cur,node.Left_son);
        Node node4;
        node4.Indice = arbre_derive.size();
        node4.Code = 'R';
        node4.Left_son = b;
        node4.Right_son = -1;
        arbre_derive.push_back(node4);

        Node node3;
        node3.Indice = arbre_derive.size();
        node3.Code = 'r';
        node3.Valeur = 2;
        node3.Left_son = -1;
        node3.Right_son = -1;
        arbre_derive.push_back(node3);

        Node node2;
        node2.Indice = arbre_derive.size();
        node2.Code = '*';
        node2.Left_son = node3.Indice;
        node2.Right_son = node4.Indice;
        arbre_derive.push_back(node2);

        Node node1;
        node1.Indice = arbre_derive.size();
        node1.Code = '/';
        node1.Valeur = 0;
        node1.Left_son = a;
        node1.Right_son = node2.Indice;
        arbre_derive.push_back(node1);
        return arbre_derive.size()-1;
        }
//driv d'un u^n
if (node.Code=='P')
        {
	  if (arbre_cur[node.Right_son].Code=='r')
	    {
	      
	      Node node2;
	      node2.Indice = arbre_derive.size();
	      node2.Code='r';
	      node2.Valeur=arbre_cur[node.Right_son].Valeur - 1;
	      node2.Left_son=-1;
	      node2.Right_son=-1;
	      arbre_derive.push_back(node2);

	      int c=Copie_de_Arbre(arbre_cur,node.Left_son);
	      Node node3;
	      node3.Indice = arbre_derive.size();
	      node3.Code='P';
	      node3.Valeur=0;
	      node3.Left_son=c;
	      node3.Right_son=node2.Indice;
	      arbre_derive.push_back(node3);

	      int a=Derive_de_Arbre(arbre_cur,node.Left_son,name);
	      Node node4;
	      node4.Indice = arbre_derive.size();
	      node4.Code='*';
	      node4.Valeur=0;
	      node4.Left_son=a;
	      node4.Right_son=node3.Indice;
	      arbre_derive.push_back(node4);

	      int d=Copie_de_Arbre(arbre_cur,node.Right_son);
	      Node node5;
	      node5.Indice = arbre_derive.size();
	      node5.Code='*';
	      node5.Valeur=0;
	      node5.Left_son=d;
	      node5.Right_son=node4.Indice;
	      arbre_derive.push_back(node5);
	      return arbre_derive.size()-1;

	    }
	  else 
	    {
	      Node node1;
	      node1.Indice = arbre_derive.size();
	      node1.Code='r';
	      node1.Valeur=1;
	      node1.Left_son=-1;
	      node1.Right_son= -1;
	      arbre_derive.push_back(node1);

	      int b=Copie_de_Arbre(arbre_cur,node.Right_son);
	      Node node2;
	      node2.Indice = arbre_derive.size();
	      node2.Code='-';
	      node2.Valeur=0;
	      node2.Left_son=b;
	      node2.Right_son=node1.Indice;
	      arbre_derive.push_back(node2);

	      int c=Copie_de_Arbre(arbre_cur,node.Left_son);
	      Node node3;
	      node3.Indice = arbre_derive.size();
	      node3.Code='P';
	      node3.Valeur=0;
	      node3.Left_son=c;
	      node3.Right_son=node2.Indice;
	      arbre_derive.push_back(node3);

	      int a=Derive_de_Arbre(arbre_cur,node.Left_son,name);
	      Node node4;
	      node4.Indice = arbre_derive.size();
	      node4.Code='*';
	      node4.Valeur=0;
	      node4.Left_son=a;
	      node4.Right_son=node3.Indice;
	      arbre_derive.push_back(node4);


	      int d=Copie_de_Arbre(arbre_cur,node.Right_son);
	      Node node5;
	      node5.Indice = arbre_derive.size();
	      node5.Code='*';
	      node5.Valeur=0;
	      node5.Left_son=d;
	      node5.Right_son=node4.Indice;
	      arbre_derive.push_back(node5);
	      return arbre_derive.size()-1;
	    }
	}


//driv d'un exp (u)
if (node.Code=='E')
        {
        int a=Derive_de_Arbre(arbre_cur,node.Left_son,name);
        int b=Copie_de_Arbre(arbre_cur,node.Left_son);
        Node node_tmp_2;
        node_tmp_2.Indice = arbre_derive.size();
        node_tmp_2.Code = 'E';
        node_tmp_2.Left_son = b;
        node_tmp_2.Right_son = -1;
        arbre_derive.push_back(node_tmp_2);
        Node node_tmp;
        node_tmp.Indice = arbre_derive.size();
        node_tmp.Code = '*';
        node_tmp.Valeur = 0;
        node_tmp.Left_son = a;
        node_tmp.Right_son = node_tmp_2.Indice;
        arbre_derive.push_back(node_tmp);
        return arbre_derive.size()-1;
        }
//driv d'un -(u)
if (node.Code=='N')
        {
        int a=Derive_de_Arbre(arbre_cur,node.Left_son,name);
        Node node_tmp;
        node_tmp.Indice = arbre_derive.size();
        node_tmp.Code = 'N';
        node_tmp.Left_son = a;
        node_tmp.Right_son = -1;
        arbre_derive.push_back(node_tmp);
        return arbre_derive.size()-1;
        }
//driv d'un ln(u)
if (node.Code=='L')
        {
        int a=Derive_de_Arbre(arbre_cur,node.Left_son,name);
        int b=Copie_de_Arbre(arbre_cur,node.Left_son);
        Node node_tmp;
        node_tmp.Indice = arbre_derive.size();
        node_tmp.Code = '/';
        node_tmp.Valeur = 0;
        node_tmp.Left_son = a;
        node_tmp.Right_son = b;
        arbre_derive.push_back(node_tmp);
        return arbre_derive.size()-1;
        }
//driv d'un u+v
if (node.Code=='+')
        {
        int a=Derive_de_Arbre(arbre_cur,node.Left_son,name);
        int b=Derive_de_Arbre(arbre_cur,node.Right_son,name);
        Node node_derive;
        node_derive.Indice = arbre_derive.size();
        node_derive.Code='+';
        node_derive.Valeur=0;
        node_derive.Left_son= a;
        node_derive.Right_son= b;
        arbre_derive.push_back(node_derive);
        return arbre_derive.size()-1;
        }
if (node.Code=='-')
        {
        int a=Derive_de_Arbre(arbre_cur,node.Left_son,name);
        int b=Derive_de_Arbre(arbre_cur,node.Right_son,name);
        Node node_derive;
        node_derive.Indice = arbre_derive.size();
        node_derive.Code='-';
        node_derive.Valeur=0;
        node_derive.Left_son= a;
        node_derive.Right_son= b;
        arbre_derive.push_back(node_derive);
        return arbre_derive.size()-1;
        }
if (node.Code=='r')
        { Node node_derive_bis;
          node_derive_bis.Indice = arbre_derive.size();
          node_derive_bis.Right_son=-1;
          node_derive_bis.Left_son=-1;
          node_derive_bis.Code='r';
          node_derive_bis.Valeur=0;
          arbre_derive.push_back(node_derive_bis);
          return arbre_derive.size()-1;
        }
if (node.Code=='V')
        { if (node.symbole==name)
          {
          Node node_derive_bis;
          node_derive_bis.Indice = arbre_derive.size();
          node_derive_bis.Right_son=-1;
          node_derive_bis.Left_son=-1;
          node_derive_bis.Code='r';
          node_derive_bis.Valeur=1;
          arbre_derive.push_back(node_derive_bis);
          return arbre_derive.size()-1;
          }
          else
          {
          Node node_derive_bis;
          node_derive_bis.Indice = arbre_derive.size();
          node_derive_bis.Right_son=-1;
          node_derive_bis.Left_son=-1;
          node_derive_bis.Code='r';
          node_derive_bis.Valeur=0;
          arbre_derive.push_back(node_derive_bis);
          return arbre_derive.size()-1;
          }
        }
}

// Arbre to Dot 
void Arbre2Dot(vector <Node> arbre_cur,int indice_node)
{
if (indice_node==-1) return;
Node node=arbre_cur[indice_node];
 if (
     (node.Code=='C') 
     or (node.Code=='P') 
     or (node.Code=='C') 
     or (node.Code=='S') 
     or (node.Code=='h') 
     or (node.Code=='i') 
     or (node.Code=='T') 
     or (node.Code=='A') 
     or (node.Code=='E') 
     or (node.Code=='L') 
     or (node.Code=='R') 
     or (node.Code=='2') 
     or (node.Code=='N')  
     )
     {
       Node nodeLeft = arbre_cur[node.Left_son];
       arbre2 << node.Indice << " -- " << nodeLeft.Indice << ";\n" ;
     }
 else if 
   ((node.Code=='+') 
     or (node.Code=='*')
     or (node.Code=='+') 
       or (node.Code=='-') )
   {Node nodeLeft = arbre_cur[node.Left_son];
   arbre2 <<  node.Indice << " -- " << nodeLeft.Indice << ";\n" ;
   Node nodeRight = arbre_cur[node.Right_son];
   arbre2 <<  node.Indice << " -- " << nodeRight.Indice << ";\n" ;
 }
 Arbre2Dot(arbre_cur, node.Left_son);
 Arbre2Dot(arbre_cur, node.Right_son);
}
;



//---------------------------------------------------------------------------
//Fonction qui transforme un arbre binaire rang dans une liste chain par des entiers en un fichier tex
void Arbre2Latex(vector <Node> arbre_cur,int indice_node)
{
if (indice_node==-1) return;
Node node=arbre_cur[indice_node];
if (node.Code=='V') {arbre2 <<  " \\pstree{\\Tr{ " << node.Name <<  "}} { \n" ;}
else if (node.Code=='r') {arbre2 <<  " \\pstree{\\Tr{ " << node.Valeur <<  "}} { \n" ;}
else if (node.Code=='P') {arbre2 <<  " \\pstree{\\Tr{ $(.)^{(.)}$ }} { \n" ;}
else if (node.Code=='C') {arbre2 <<  " \\pstree{\\Tr{ $\\cos$ }} { \n" ;}
else if (node.Code=='S') {arbre2 <<  " \\pstree{\\Tr{ $\\sin$ }} { \n" ;}
else if (node.Code=='h') {arbre2 <<  " \\pstree{\\Tr{ $\\cosh$ }} { \n" ;}
else if (node.Code=='i') {arbre2 <<  " \\pstree{\\Tr{ $\\sinh$ }} { \n" ;}
else if (node.Code=='T') {arbre2 <<  " \\pstree{\\Tr{ $\\tan$ }} { \n" ;}
else if (node.Code=='A') {arbre2 <<  " \\pstree{\\Tr{ \arctan }} { \n" ;}
else if (node.Code=='E') {arbre2 <<  " \\pstree{\\Tr{ $\\exp$ }} { \n" ;}
else if (node.Code=='L') {arbre2 <<  " \\pstree{\\Tr{ $\\ln$  }} { \n" ;}
else if (node.Code=='R') {arbre2 <<  " \\pstree{\\Tr{ $\\sqrt{(.})$ }} { \n" ;}
else if (node.Code=='2') {arbre2 <<  " \\pstree{\\Tr{ $(.)^2$   }} { \n" ;}
else if (node.Code=='N') {arbre2 <<  " \\pstree{\\Tr{ $(-)$   }} { \n" ;}
else if (node.Code=='p') {arbre2 <<  " \\pstree{\\Tr{ $\\partial_{" <<  node.symbole  << " }$   }} { \n" ;}

else {arbre2 <<  " \\pstree{\\Tr{ " << node.Code <<  " }} { \n" ;}
Arbre2Latex(arbre_cur, node.Left_son);
Arbre2Latex(arbre_cur, node.Right_son);
arbre2 << "}" << endl;
}
;




//Fonction rcursive qui value
interval Eval(vector <Node> arbre_cur,int indice_node, domain p)
{
Node node= arbre_cur[indice_node];
char e=node.Code;
if (node.Code=='*')
        {
        interval a=Eval(arbre_cur,node.Left_son,p);
        interval b=Eval(arbre_cur,node.Right_son,p);
        return a*b;
        }
if (node.Code=='/')
        {
        interval a=Eval(arbre_cur,node.Left_son,p);
        interval b=Eval(arbre_cur,node.Right_son,p);
        return a/b;
        }
if (node.Code=='C')
        {
        interval a=Eval(arbre_cur,node.Left_son,p);
        return cos(a);
        }
if (node.Code=='S')
        {
        interval a=Eval(arbre_cur,node.Left_son,p);
        return sin(a);
        }
if (node.Code=='h')
        {
        interval a=Eval(arbre_cur,node.Left_son,p);
        return cosh(a);
        }
if (node.Code=='i')
        {
        interval a=Eval(arbre_cur,node.Left_son,p);
        return sinh(a);
        }
if (node.Code=='N')
        {
        interval a,b;
        a = Eval(arbre_cur,node.Left_son,p);
        b =interval(0,0)-a;
        return b;
        }
if (node.Code=='R')
        {
        interval a=Eval(arbre_cur,node.Left_son,p);
        return sqrt(a);
        }
if (node.Code=='P')
        {
        interval a=Eval(arbre_cur,node.Left_son,p);
	interval b=Eval(arbre_cur,node.Right_son,p);
        double c=b.sup();
        int j=int(c);
        return power(a,j);
        }
if (node.Code=='E')
        {
        interval a=Eval(arbre_cur,node.Left_son,p);
        return exp(a);
        }
if (node.Code=='L')
        {
        interval a=Eval(arbre_cur,node.Left_son,p);
        return log(a);
        }
if (node.Code=='+')
        {
        interval a=Eval(arbre_cur,node.Left_son,p);
        interval b=Eval(arbre_cur,node.Right_son,p);
        return a+b;
        }
if (node.Code=='-')
        {
        interval a=Eval(arbre_cur,node.Left_son,p);
        interval b=Eval(arbre_cur,node.Right_son,p);
        return a-b;
        }
if (node.Code=='r')
        { interval a = interval(node.Valeur,node.Valeur);
          return a;
        }
if (node.Code=='V')
        { 
          return p[node.symbole];
        }
}
//fin de la fonction eval avec un domaine


//Fonction rcursive qui calcule les coef de taylor, correspond   une mthode forward ?
vector <double> Taylor(vector <Node> arbre_cur,int indice_node, domain p, int ordre )
{
Node node= arbre_cur[indice_node];

if (node.Code=='E')
        {
	  vector <double> P = Taylor(arbre_cur,node.Left_son,p,ordre);
	  vector <double> result; 
	  result.push_back(exp(P[0]));
	  for(int i=1;i<=ordre;i++) // On parcourt le tableau.
	    {
	      double ieme = 0;
	      for(int j=0;j<=i-1;j++) // On parcourt le tableau.
		{
	      	  ieme = ieme + (i-j)*result[j]*P[i-j];
		}
	      result.push_back(ieme/i);
	    }
	  return result;
        }

if (node.Code=='*') // multiplication
        {
	  vector <double> a = Taylor(arbre_cur,node.Left_son,p,ordre);
	  vector <double> b = Taylor(arbre_cur,node.Right_son,p,ordre);
	  vector <double> result; 
	  for(int i=0;i<=ordre;i++) // On parcourt le tableau.
	    {
	      double ieme = 0;
	      for(int j=0;j<=i;j++) // On parcourt le tableau.
		{
		  ieme = ieme + a[j]*b[i-j];
		}
	      result.push_back(ieme);
	    }
	  return result;
        }
if (node.Code=='+')
        {
	  vector <double> a = Taylor(arbre_cur,node.Left_son,p,ordre);
	  vector <double> b = Taylor(arbre_cur,node.Right_son,p,ordre);
	  vector <double> result; 
	  for(int i=0;i<=ordre;i++) // On parcourt le tableau.
	    {
	      result.push_back(a[i] + b[i]);
	    }
	    return result;
        }
if (node.Code=='-')
        {
	  vector <double> a = Taylor(arbre_cur,node.Left_son,p,ordre);
	  vector <double> b = Taylor(arbre_cur,node.Right_son,p,ordre);
	  vector <double> result; 
	  for(int i=0;i<=ordre;i++) // On parcourt le tableau.
	    {
	      result.push_back(a[i] - b[i]);
	    }
	    return result;
        }

if (node.Code=='r')
        {
	  vector <double> result;
	  result.push_back(node.Valeur);
	  for(int i=1;i<=ordre;i++) // On parcourt le tableau.
	    {
	      result.push_back(0);
	    }
	  return result;
        }

 if (node.Code=='V') // pour une variable
        { 
	  vector <double> result; 
	  result.push_back(p[node.symbole].inf());	 
	  for(unsigned int i=1;i<=ordre;i++) // On parcourt le tableau, 0 partout sauf dans la case 0 et 1.
	    {
	      result.push_back(0);
	    }
	  result[1] = 1;
	  return result;
        }
}
//fin de la fonction rcursive taylor avec un domaine

vector <double> expression::taylor_f(domain p, int ordre) 
{
  return Taylor(arbre_node,arbre_node.size()-1,p, ordre);
}



//Fonction rcursive qui calcule les coef de taylor, correspond   une mthode forward.
vector <interval> Taylor_ode(vector <Node> arbre_cur,int indice_node, taylor p, int ordre )
{
Node node= arbre_cur[indice_node];

if (node.Code=='*') // multiplication
        {
	  vector <interval> a = Taylor_ode(arbre_cur,node.Left_son,p,ordre);
	  vector <interval> b = Taylor_ode(arbre_cur,node.Right_son,p,ordre);
	  vector <interval> result; 
	  for(int i=0;i<=ordre;i++) // On parcourt le tableau.
	    {
	      interval ieme = interval(0);
	      for(int j=0;j<=i;j++) // On parcourt le tableau.
		{
		  ieme = ieme + a[j]*b[i-j];
		}
	      result.push_back(ieme);
	    }
	  return result;
        }


// pour ce cas, voir le livre de Griewank, Evaluating derivatives Principles and Techniques page 308
if (node.Code=='P') // power
        {
	  vector <interval> a = Taylor_ode(arbre_cur,node.Left_son,p,ordre);
	  vector <interval> b = Taylor_ode(arbre_cur,node.Right_son,p,ordre);
	  interval exposant = b[0]; 
	  vector <interval> result; 
	  double c=b[0].sup();
	  int exposant_entier=int(c);
	  
	  result.push_back(power(a[0],exposant_entier));	  

	  if (!interval(0).subset(result[0]))
	    {	  
	      for(int k=1;k<=ordre;k++) // On parcourt le tableau.
		{
		  interval ieme = interval(0);
		  for(int i=0;i<=k-1;i++) // On parcourt le tableau.
		    {
		      ieme = ieme + interval(ordre)*interval((k-i))*(result[i]*a[k-i]);
		    }
		  
		  for(int i=1;i<=k-1;i++) // On parcourt le tableau.
		    {
		      ieme = ieme - interval((k-i))*result[k-i]*a[i];
		    }
		  
		  result.push_back(ieme/(interval(k)*result[0]));
		}
	    }
	  else
	    {
	      result = a;      
	      for(int k=2;k<=exposant_entier;k++) // on decompose a^n en a * a * a n fois betement
		{		    
		  // produit de result par a
  		  vector <interval> new_result;
		  for(int i=0;i<=ordre;i++) 
		    {
		      interval ieme = interval(0);
		      for(int j=0;j<=i;j++) 
			{
			  ieme = ieme + result[j]*a[i-j];
			}
		      new_result.push_back(ieme);
		    }
		  result = new_result;
		  // fin produit de result par a
		}
	    }
	  return result;
        }



// pour ce cas, voir le livre de Griewank, Evaluating derivatives Principles and Techniques page 308
if (node.Code=='C' || node.Code=='S') // cos  ou sin
        {
	  vector <interval> a = Taylor_ode(arbre_cur,node.Left_son,p,ordre);
	  vector <interval> result_cos; 
	  vector <interval> result_sin; 
	  result_cos.push_back(cos(a[0]));
	  result_sin.push_back(sin(a[0]));

	  for(int k=1;k<=ordre;k++)
	    {
	      interval keme_cos = interval(0);
	      interval keme_sin = interval(0);
	      for(int i=0;i<=k-1;i++) 
		{
	      	  keme_cos = keme_cos - result_sin[i]*interval((k-i))*a[k-i];
	      	  keme_sin = keme_sin + result_cos[i]*interval((k-i))*a[k-i];
		}
	      result_cos.push_back(keme_cos/interval(k));
	      result_sin.push_back(keme_sin/interval(k));
	    }
	  if (node.Code=='C') return result_cos;
	  if (node.Code=='S') return result_sin;
        }
 

 if (node.Code=='E') // exponential
        {
	  vector <interval> a = Taylor_ode(arbre_cur,node.Left_son,p,ordre);
	  vector <interval> result; 
	  result.push_back(exp(a[0]));
	  for(int i=1;i<=ordre;i++) // On parcourt le tableau.
	    {
	      interval ieme = interval(0);
	      for(int j=0;j<=i-1;j++) // On parcourt le tableau.
		{
	      	  ieme = ieme + interval((i-j))*result[j]*a[i-j];
		}
	      result.push_back(ieme/interval(i));
	    }
	  return result;
        }

if (node.Code=='+')
        {
	  vector <interval> a = Taylor_ode(arbre_cur,node.Left_son,p,ordre);
	  vector <interval> b = Taylor_ode(arbre_cur,node.Right_son,p,ordre);
	  vector <interval> result; 
	  for(int i=0;i<=ordre;i++)
	    {
	      result.push_back(a[i] + b[i]);
	    }
	    return result;
        }
if (node.Code=='-')
        {
	  vector <interval> a = Taylor_ode(arbre_cur,node.Left_son,p,ordre);
	  vector <interval> b = Taylor_ode(arbre_cur,node.Right_son,p,ordre);
	  vector <interval> result; 
	  for(int i=0;i<=ordre;i++) // On parcourt le tableau.
	    {
	      result.push_back(a[i] - b[i]);
	    }
	    return result;
        }
if (node.Code=='N')
        {
	  vector <interval> result; 
	  vector <interval> a = Taylor_ode(arbre_cur,node.Left_son,p,ordre);
	  for(int i=0;i<=ordre;i++) // On parcourt le tableau.
	    {
	      result.push_back(-a[i]);
	    }
	    return result;
        }

if (node.Code=='r')
        {
	  vector <interval> result;
	  result.push_back(node.Valeur);
	  for(int i=1;i<=ordre;i++) // On parcourt le tableau.
	    {
	      result.push_back(0);
	    }
	  return result;
        }

 if (node.Code=='V') // pour une variable
        { 
	  vector <interval> result;	  
	  for(int i=0;i<=ordre;i++) // On parcourt le tableau.
	    {
	      result.push_back(p[node.symbole][i]);
	    }
	  return result;	 
        }
}
//fin de la fonction rcursive taylor_ode avec un domaine

vector <interval> expression::taylor_ode(taylor p, int ordre) 
{
  return Taylor_ode(arbre_node,arbre_node.size()-1,p, ordre);
}


interval expression::forme_centre(domain x)
{
  domain centre = x.center();
  interval result = Evalue(centre);
  map < string, expression > df;
  for (set<string>::const_iterator var = variables.begin(); var != variables.end(); ++var)
    {
      result = result + (x[*var]-centre[*var])*derive(*var).Evalue(x);
    }
 return result;
}



void expression::Simplify()
{
  bool fini;
  do 
    {
      fini = simplify();
    }
  while (fini==false);
  ArbreToChaine();
}

bool expression::simplify()
{
  Node noeud;
  Node noeud2;
  Node noeud_fils_gauche;
  Node noeud_fils_droit;
  for (int i=arbre_node.size()-1; i >= 0 ; i--)
    {
      noeud = arbre_node[i];
      if ((noeud.Left_son != -1) && (noeud.Right_son != -1))
	{
	  noeud_fils_gauche = arbre_node[noeud.Left_son];
	  noeud_fils_droit = arbre_node[noeud.Right_son];
	  //simplification de 1*x
	  if ((noeud.Code=='*') && (noeud_fils_gauche.Code=='r') && (noeud_fils_gauche.Valeur==1))
	    {
	      noeud = noeud_fils_droit;
	      noeud.Indice = i;
	      arbre_node[i] = noeud  ;
	      return false;
	    }
	  //simplification de x*1
	  if ((noeud.Code=='*') && (noeud_fils_droit.Code=='r') && (noeud_fils_droit.Valeur==1))
	    {
	      noeud = noeud_fils_gauche;
	      noeud.Indice = i;
	      arbre_node[i] = noeud  ;
	      return false;
	    }
	  //simplification de x+0
	  if ((noeud.Code=='+') && (noeud_fils_droit.Code=='r') && (noeud_fils_droit.Valeur==0))
	    {
	      noeud = noeud_fils_gauche;
	      noeud.Indice = i;
	      arbre_node[i] = noeud  ;
	      return false;
	    }
	  //simplification de x-0
	  if ((noeud.Code=='-') && (noeud_fils_droit.Code=='r') && (noeud_fils_droit.Valeur==0))
	    {
	      noeud = noeud_fils_gauche;
	      noeud.Indice = i;
	      arbre_node[i] = noeud  ;
	      return false;
	    }
	  //simplification de 0+x
	  if ((noeud.Code=='+') && (noeud_fils_gauche.Code=='r') && (noeud_fils_gauche.Valeur==0))
	    {
	      noeud = noeud_fils_droit;
	      noeud.Indice = i;
	      arbre_node[i] = noeud  ;
	      return false;
	    }
	  //simplification de 0*x
	  if ((noeud.Code=='*') && (noeud_fils_gauche.Code=='r') && (noeud_fils_gauche.Valeur==0))
	    {
	      noeud = noeud_fils_gauche;
	      noeud.Indice = i;
	      arbre_node[i] = noeud  ;
	      return false;
	    }
	  //simplification de x*0
	  if ((noeud.Code=='*') && (noeud_fils_droit.Code=='r') && (noeud_fils_droit.Valeur==0))
	    {
	      noeud = noeud_fils_droit;
	      noeud.Indice = i;
	      arbre_node[i] = noeud ;
	      return false;
	    }

	  //simplification de u^1
	  if ((noeud.Code=='P') && (noeud_fils_droit.Code=='r') && (noeud_fils_droit.Valeur==1))
	    {
	      noeud = noeud_fils_gauche;
	      noeud.Indice = i;
	      arbre_node[i] = noeud  ;
	      return false;
	    }
	}

      //simplification de -0
      if ((noeud.Code=='N') && ( arbre_node[noeud.Left_son].Code=='r') && (arbre_node[noeud.Left_son].Valeur==0))
	{
	  noeud = arbre_node[noeud.Left_son];
	  noeud.Indice = i;
	  arbre_node[i] = noeud  ;
	  return false;
	}
    }
  return true;
};


void expression::ToDot(char * filename)
{
char *sPhrase2;
arbre2.open(filename,fstream::out);
arbre2 << "graph G {" << endl;

for (int i=0; i < arbre_node.size() ; i++)
{
  arbre2 << arbre_node[i].ToDot();
}



Arbre2Dot(arbre_node,arbre_node.size()-1); 
arbre2 << "}" << endl;
arbre2.close();
}



void expression::ToLatex(char * filename)
{
char *sPhrase2;
arbre2.open(filename,fstream::out);
arbre2 << " \\documentclass[a4paper,11pt]{article} \\usepackage[french]{babel} \\usepackage[T1]{fontenc} \\usepackage[latin1]{inputenc} \\usepackage{theorem} \\usepackage{amsfonts} \\usepackage{pst-all} \\begin{document} \\psset{levelsep=20pt,nodesep=2pt,linecolor=green}" << endl;
/*string Tmp= "$" + chaine +" $;\\\\";
  sPhrase2 = Tmp.c_str();*/

 arbre2 << "\\[" << chaine  << "\\]" << endl;
Arbre2Latex(arbre_node,arbre_node.size()-1); 
arbre2 << " \\\\ \n \\begin{tabular}{|l|l|l|l|l|l|}" <<endl;
arbre2 << " \\hline" <<endl;
for (int i=0; i < arbre_node.size() ; i++)
{
arbre2 << i;
arbre2 << "&";
arbre2 << arbre_node[i].Code;
arbre2 << "&";
arbre2 << arbre_node[i].Left_son;
arbre2 << "&";
arbre2 << arbre_node[i].Right_son;
arbre2 << "&";
if (arbre_node[i].Code=='V') {arbre2 << arbre_node[i].symbole;}
if (arbre_node[i].Code=='p') {arbre2 << arbre_node[i].symbole;}
arbre2 << "&";
if (arbre_node[i].Code=='r') arbre2 << arbre_node[i].Valeur;
arbre2 << "\\\\ \\hline" <<endl;
}
arbre2 << " \\end{tabular}";
arbre2 << " \\end{document}" << endl;
arbre2.close();
}





int expression::creation_arbre_de_node()
{
  liste_symboles.clear();
  arbre_de_node.clear();
  string Tmp= chaine+";";
  yy_scan_string(Tmp.c_str());
  int err = yyparse();
  int j=arbre_de_node.size();
  arbre_node = arbre_de_node;
}


expression expression::derive(string name)
{
expression expr_derive;
arbre_derive.clear();
Derive_de_Arbre(arbre_node,arbre_node.size()-1,name);
expr_derive.arbre_node=arbre_derive;
expr_derive.Simplify();
expr_derive.ArbreToChaine();
return expr_derive;
}

// Constructeur
expression::expression()
{
arbre_node.clear();
chaine="";
}

// Constructeur
expression::expression(string ch)
{
arbre_node.clear();
chaine=ch;
creation_arbre_de_node();
variables_eq();
//;
}


//Fonction rcursive qui cre la chaine  partir de l'arbre
//--------------------------------------------------------

string Arbre2Chaine(vector <Node> arbre_cur,int indice_node)
{
Node node= arbre_cur[indice_node];
char e=node.Code;
if (node.Code=='*')
        {
        string a=Arbre2Chaine(arbre_cur,node.Left_son);
        string b=Arbre2Chaine(arbre_cur,node.Right_son);
        return ("(") + a + (")") + ("*") + ("(") +  b + (")");
        }
if (node.Code=='/')
        {
        string a=Arbre2Chaine(arbre_cur,node.Left_son);
        string b=Arbre2Chaine(arbre_cur,node.Right_son);
        return ("(") + a + (")") + ("/") + ("(") + b + (")") ;
        }
if (node.Code=='C')
        {
        string a=Arbre2Chaine(arbre_cur,node.Left_son);
        return ("cos(") + a + (")");
        }
if (node.Code=='S')
        {
        string a=Arbre2Chaine(arbre_cur,node.Left_son);
        return ("sin(")+ a + (")");
        }
if (node.Code=='h')
        {
        string a=Arbre2Chaine(arbre_cur,node.Left_son);
        return ("cosh(")+a+(")");
        }
if (node.Code=='i')
        {
        string a=Arbre2Chaine(arbre_cur,node.Left_son);
        return ("sinh(")+a+(")");
        }
if (node.Code=='N')
        {
        string a,b;
        a = Arbre2Chaine(arbre_cur,node.Left_son);
        b = ("(-(")+a+("))");
        return b;
        }
if (node.Code=='R')
        {
        string a=Arbre2Chaine(arbre_cur,node.Left_son);
        return ("sqrt(")+a+(")");
        }
if (node.Code=='P')
        {
        string a=Arbre2Chaine(arbre_cur,node.Left_son);
        string b=Arbre2Chaine(arbre_cur,node.Right_son);
        return ("(")+ a+(")^(") + b+(")") ;
        }
if (node.Code=='E')
        {
        string a=Arbre2Chaine(arbre_cur,node.Left_son);
        return ("exp(")+a+(")");
        }
if (node.Code=='L')
        {
        string a=Arbre2Chaine(arbre_cur,node.Left_son);
        return ("log(")+a+(")");
        }
if (node.Code=='+')
        {
        string a=Arbre2Chaine(arbre_cur,node.Left_son);
        string b=Arbre2Chaine(arbre_cur,node.Right_son);
        return a +  ("+")+  b   ;
        }
if (node.Code=='-')
        {
        string a=Arbre2Chaine(arbre_cur,node.Left_son);
        string b=Arbre2Chaine(arbre_cur,node.Right_son);
        return ("(") + a + (")") +  ("-")+ ("(") + b + (")");
        }
if (node.Code=='r')
        {
	  string a;
	  std::ostringstream oss;
	  oss << node.Valeur;
	  a = oss.str();
          return a;
        }
if (node.Code=='V')
        { 
	  return node.symbole;
	}
}


void expression::ArbreToChaine()
{
chaine = Arbre2Chaine(arbre_node,arbre_node.size()-1);
};


interval expression::Evalue(domain p) 
{
return Eval(arbre_node,arbre_node.size()-1,p);
}


//----------------------------------------------------------------
// Fonction rcursive trouve les variables d'une expression
// 
set <string> variables2eq(vector <Node> arbre_cur,int indice_node)
{
  Node node = arbre_cur[indice_node];
  char c = node.Code;

  if ((c=='+') || (c=='-') || (c=='*') || (c=='/') )
        {
        set <string > a=variables2eq(arbre_cur,node.Left_son);
        set <string > b=variables2eq(arbre_cur,node.Right_son);
	
	std::set <string> temp_set;
	std::set_union(a.begin(), a.end(), 
		       b.begin(), b.end(), 
		       inserter(temp_set,temp_set.begin()));		      
	return temp_set; 
        }
  
  if ((c=='C') || (c=='S') || (c=='h') || (c=='i') || (c=='N') || (c=='R') || (c=='P') || (c=='E') || (c=='L') )
      {
        return variables2eq(arbre_cur,node.Left_son);
      }

  if ((c=='V') || (c=='p'))
    {
      std::set <string> temp2_set;
      temp2_set.insert(node.symbole);
      return temp2_set;
      }

   if (c=='r')
     {
          set <string > empty;
	  return empty;
     }
}


void expression::variables_eq()
{
  set <string > temp;
  temp = variables2eq(arbre_node,arbre_node.size()-1);
  variables = temp;
}


expression expression::substitute(string new_variable, string old)
{

  expression result;
  result = (*this);

   for(int i=0; i < result.arbre_node.size(); i++)
   {
     if ((result.arbre_node[i].Code=='V') && (result.arbre_node[i].symbole==old))
       {
	 result.arbre_node[i].symbole=new_variable;
       }
   }
     
  result.ArbreToChaine();
  result.Simplify();
  result.variables_eq();

  return result;


}



expression expression::substitute(double value, string variable)
{
  expression result;
  result = (*this);
   for(int i=0; i < result.arbre_node.size(); i++)
   {
     if ((result.arbre_node[i].Code=='V') && (result.arbre_node[i].symbole==variable))
       {
	 result.arbre_node[i].Code = 'r'; 
	 result.arbre_node[i].Valeur = value;
       }
   }
     
  result.ArbreToChaine();
  result.Simplify();
  result.variables_eq();

  return result;


}




//---------------------------------------------------------------------
// Fonction rcursive qui change partial_x en 1 et partial_pas(x) en 0 
// --------------------------------------------------------------------
expression expression::substitue_partial(string x)
{
  expression expr_subst;
  expr_subst = (*this);

  
   for(int ii=0; ii < expr_subst.arbre_node.size(); ii++)
   {
     if ((expr_subst.arbre_node[ii].Code=='p') && (expr_subst.arbre_node[ii].symbole==x))
       {
	 expr_subst.arbre_node[ii].Code='r';
	 expr_subst.arbre_node[ii].Valeur=1;
       }
     if ((expr_subst.arbre_node[ii].Code=='p') && (expr_subst.arbre_node[ii].symbole!=x))
       {
	 expr_subst.arbre_node[ii].Code='r';
	 expr_subst.arbre_node[ii].Valeur=0;
       }
   }
     
  expr_subst.ArbreToChaine();
  expr_subst.Simplify();
  return expr_subst;

}


expression expression::operator+(expression v)
{
  string temp = "(" + chaine + ")" + "+" + "(" + v.chaine + ")";
  expression result( temp ) ;  
  result.Simplify();
  return result;
}


expression expression::operator*(expression v)
{
  string temp = "(" + chaine + ")" + "*" + "(" + v.chaine + ")";
  expression result( temp ) ;  
  result.Simplify();
  return result;
}


expression expression::operator-(expression v)
{
  string temp = "(" + chaine + ")" + "-" + "(" + v.chaine + ")";
  expression result( temp ) ;  
  result.Simplify();
  return result;
}


expression expression::pow(int i)
{

  std::string s;
  std::stringstream out;
  out << i;
  s = out.str();
  
  string temp = "(" + chaine + ")^"+s;
  expression result( temp ) ;  
  result.Simplify();
  return result;
}


