#include "newton.h"

newton::newton(Map _f)
{
  f = _f;
  Df = f.differentielle();
  // Df.out();
}


void newton::out()
{
  f.out();
  Df.out();
}



domain newton::operator_newton(domain x)
{
  domain center = x.center();
  domain result = center-Df.evalue(x).gaussian(f.evalue(center));


  // ceci est une gestion pas très heureuse du cas de matrice interval non inversible ...
  // des que une des composantes est non bornées, toutes les autres deviennent aussi non bornés ...
  bool infini = false;
  for (map<string,interval>::const_iterator i = result.begin(); i!=result.end();++i)
    infini =  (result[i->first].isInfinite()) || infini;

  if (infini) 
    {
      for (map<string,interval>::const_iterator i = result.begin(); i!=result.end();++i)
	result[i->first] = interval::ENTIRE();
    }


    return result;
  

}


