#ifndef _vecteur_n
#define _vecteur_n

#include <vector>
#include <math.h>


using namespace std; 

template< class T> class vector_nD : public vector <T>
{
public :
         // Constructor
         vector_nD(const vector < T > & v) : vector<T>(v)
         {
         }
         vector_nD() : vector<T>(){}

         // retourne la norme de ce vecteur
         T norme() const
	   {
         T result = 0;
         int size_0 = (*this).size();
         for (int i=0; i < size_0 ;i++)
         result = result + pow((*this)[i],2);
         result = sqrt(result);
         return result;
	 }
};


#endif
 
